<?php
/*
 * @(#) $Header: /var/cvsroot/pop3ml/includes/Attic/class.pop3ml.php,v 1.18.2.70 2009/09/23 05:55:18 cvs Exp $
 */
/*  pop3ml - php Mailing list/Newsletter manager
    Copyright (C) 2009- Giuseppe Lucarelli <giu.lucarelli@gmail.it>

    This program is free software; you can redistribute it and/or modify
    it under the terms of version 2 of the GNU General Public License as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* Debugging / Contributers:
 * Ron Schoellmann
 * Gregor Buchholz
 */

require_once(SCRIPTS_DIR_PATH.DS.'smtp.php');
require_once(SCRIPTS_DIR_PATH.DS.'mime_parser.php');
require_once(SCRIPTS_DIR_PATH.DS.'rfc822_addresses.php');
require_once(SCRIPTS_DIR_PATH.DS."pop3.php");
require_once(SCRIPTS_DIR_PATH.DS.'sasl.php');    /* for gmail */
//--------------------------------------------------------------------------------
// if you want a more complex bounce detection or you if have almost one puclic ML use this extra class (refer to README file)
//--------------------------------------------------------------------------------
if(file_exists(SCRIPTS_DIR_PATH.DS."bounce_driver.class"))
    require_once(SCRIPTS_DIR_PATH.DS.'bounce_driver.class');

class MyPop3 extends pop3_class {
    var $decoded;
}

class Pop3Ml
{
/* public */
    var $mltable = '';
    var $messagesTable = '';
    var $listname = '';
    var $listaddress = '';
    var $listhostname = '';
    var $listpost = '';
    var $listport = '';
    var $listtls = '';
    var $listuser = '';
    var $listpassword = '';
    var $allow = array();
    var $deny = array();
    var $removeAfterPop = '';
    var $moderatedlist = '';
    var $modsublist = '';
    var $listowner = '';
    var $maxmsgsize = '';
    var $headersadd = array();
    var $logheader = '';
    var $sublist = '';
    var $digestsublist = '';
    var $expirelock = false;
    var $cachemessages = false;
    var $cachepath = false;
    var $mintimeresendmsg = false;
    var $senddigest = false;
    var $digestmaxmsg = false;
    var $mlsmtp = array();
/* private */
    var $now = '';
    var $dbconn = '';
    var $dbrow = '';
    var $pop3='';
    var $decoded='';
    var $smtp='';
    var $smtpindex='';
    var $error='';
    /**
     * debug variables are used by 'test_pop3ml.php' script too.
     * if you are using this script these variables are set automatically from the web form.
     * for normal use instead you have to set manually their values, just pay attention to '$smtpDebug' value:
     * if set to 0 the message(s) won't be really sent to subscribed addresses
     * if set to 1 the message(s) will be sent and 'smtp.php' will display the complete transaction's output
     */
    var $debugOutput='';
    var $debug=0;
    var $smtpDebug=0;
    /*
     * the following variable is for normal use only. set its value to '1' for pop3 debug
     */
    var $pop3Debug=0;
    var $bodytextplain = '';
    // this variable is used to avoid looping thru parent/children sublist
    var $recursivelist = '';
    
    // this function is call once
    function Init() {
        $this->debugOutput = '';
        //-------------------
        // thanks to Ron and Gregor
        if(!in_array("pop3", stream_get_wrappers())) {
            stream_wrapper_register('pop3', 'pop3_stream');  /* Register the pop3 stream handler class */
        }
        $this->pop3 = new pop3_class;
        //-------------------
        if(!$this->mltable) $this->mltable = 'mltable';
        if(!$this->messagesTable) $this->messagesTable = 'messages';
        if(!$this->queue) $this->queue = 'queue';
        if(!$this->subqueue) $this->subqueue = 'subqueue';
        if(!$this->subscribers) $this->subscribers = 'subscribers';
        $query = "select * from ".addslashes($this->mltable)." where listname = '".$this->listname."'";
        $command = @mysql_query($query,$this->dbconn);
        if(!$result = @mysql_fetch_object($command)) {
            if($this->debug) {
                $this->debugOutput .= "\nERROR: no ML found, quit\n";
            } else {
                echo "no ML found: quit; ";
            }
            return false;
        }
        $this->dbrow = $result;
        $this->listuser=$this->dbrow->listuser;
        $this->listpassword=$this->dbrow->listpoppass;
        $this->maxmsgsize=$this->dbrow->msgsize;
        $this->removeAfterPop=$this->dbrow->removeafterpop;
        $this->moderatedlist=$this->dbrow->moderatedlist;
        $this->listowner=$this->dbrow->listowneremail;
        $this->listaddress=$this->dbrow->listaddr;
        $this->mlsmtp=explode("\n",$this->dbrow->smtpserver);
        // for compatibily with previuos release 0.1
        $this->headersadd=str_replace('::',' ',$this->SetText($this->dbrow->headerchange));
        $this->smtpindex=0;    // use default smtp server
        if(CACHE_MESSAGES == false)
            $this->cachemessages = false;
        if(CACHE_PATH != false) {
            $this->cachepath = CACHE_PATH;
        }
        if($this->cachepath && strlen($this->cachepath) > 1 && $this->cachepath[strlen($this->cachepath)-1] != '/') {
            $this->cachepath .= '/';
        }
        if($this->mintimeresendmsg != false)
            $this->mintimeresendmsg = MIN_TIME_RESEND_MSG;
        $this->senddigest = ($this->dbrow->senddigest ? $this->dbrow->senddigest :
                                    SEND_DIGEST);
        if(DIGEST_MAX_MSG == false) {
            $this->digestmaxmsg = $this->dbrow->digestmaxmsg;
        } else {
            $this->digestmaxmsg = DIGEST_MAX_MSG;
        }
        if(!$this->digestmaxmsg)
            $this->digestmaxmsg = 30;
        return true;
    }

    function InitSublistFields() {
        $this->dbrow->sublist=trim($this->dbrow->sublist);
        $this->dbrow->digestsublist=trim($this->dbrow->digestsublist);
        $this->dbrow->allowsublist=trim($this->dbrow->allowsublist);
        $this->dbrow->denysublist=trim($this->dbrow->denysublist);
        $this->sublist=$this->BuildRecursiveList($this->dbrow->sublist,'sublist',false);
        $this->digestsublist=$this->BuildRecursiveList($this->dbrow->digestsublist,'digestsublist',false);
        $this->modsublist=$this->BuildRecursiveList($this->dbrow->modsublist,'modsublist',false);
        // $this->allow/$this->deny are build as array because every address may contain a REGEXP pattern
        // (ie. '.*' '.*@bmsc.it')
        $this->allow=$this->BuildRecursiveList($this->dbrow->allowsublist,'allowsublist',true);
        $this->deny=$this->BuildRecursiveList($this->dbrow->denysublist,'denysublist',true);
        // if 'parentlist' is set append parent subscribers list as allowed addresses
        if(strlen($this->dbrow->parentlist) > 0) {
            $arr = explode(',',$this->dbrow->parentlist);
            foreach($arr as $token) {
                 $this->allow=array_merge((is_array($this->allow) ? $this->allow : array()),
                     $this->BuildRecursiveList(trim($token),'sublist',true));
            }
        }
    }

    function BuildRecursiveList($list,$listtype,$asarray = false, $depth = 0) {
        $retval = '';
        $sublist = ($asarray == true ? array() : '');

        if($depth == 0) {
            $this->recursivelist = '';
        }
        if(strlen($list) <= 2)
            return $retval;
        $retval = explode("\n",str_replace("\r",'',trim($list,"\n\r ,;")));
        while(list($key,$value) = each($retval)) {
            // check if address is valid or sublist name
            if(ereg("[ '\*\^\$\"\\\{\[]",$value)) {    // got REGEXP value from address, jump
                continue;
            }
            if(strpos($value,'@'))
                continue;
            // got child list, check if already read
            if(strstr($this->recursivelist,$value)) {
                array_splice($retval,$key,1);
                continue;
            }
            $this->recursivelist .= $value."\n";
            $query = "select $listtype from $this->mltable where listname = '$value'";
            if(!$command=@mysql_query($query,$this->dbconn))
                continue;
            // TODO: insert ml status check (if ml is disabled do something)
            if(!$result = @mysql_fetch_row($command))
                continue;
            array_splice($retval,$key,1);
            if(strlen($result[0]) > 7) {
                if($asarray == true) {
                    $sublist = array_merge($sublist,
                            $this->BuildRecursiveList($result[0],$listtype,$asarray,++$depth));
                } else {
                    $sublist .= $this->BuildRecursiveList($result[0],$listtype,$asarray,++$depth)."\n";
                }
            }
            @mysql_free_result($result);
        }
        if($asarray == true) {
            return array_merge($retval,$sublist);
        } else {
            return trim(implode("\n",$retval)."\n".$sublist,"\n");
        }
    }

    //------------------------------------------------------------------------------
    // if smtp server doesn't require pop auth, set to '' pop3_auth_port, user, password)
    //------------------------------------------------------------------------------
    function SmtpInit() {
        $this->smtp=new smtp_class;

        $this->smtp->localhost="localhost";
        $this->smtp->direct_delivery=0;
        $this->smtp->timeout=10;
        $this->smtp->data_timeout=0;
        $this->smtp->debug=0;
        $this->smtp->html_debug=0;
        $this->smtp->pop3_auth_host='';
        $this->smtp->realm="";
        $this->smtp->workstation="";
        $this->smtp->authentication_mechanism="";
        $token = explode(':',trim($this->mlsmtp[$this->smtpindex]));
        $this->smtp->host_name=$token[0];
        $this->smtp->host_port=$token[1];
        $this->smtp->ssl=$token[2];
        $this->smtp->pop3authport='';
        $this->smtp->user='';
        $this->smtp->password='';
        if($token[3]) $this->smtp->pop3authport=$token[3];
            if($token[4]) $this->smtp->user=$token[4];
            if($token[5]) $this->smtp->password=$token[5];
    }

    function &SetText(&$text, $useraddress = '') {
        return(str_replace(array("__USERADDRESS__","__LISTADDRESS__","__LISTNAME__","__LISTOWNER__","__LISTHELP__"),
                 array($useraddress,$this->listaddress,$this->listname,$this->listowner,$this->listaddress),$text));
    }

    function ArraySplit(&$item) {
        $retval = array();
        $recipientlimit = ($this->dbrow->recipientlimit ? $this->dbrow->recipientlimit : 0);
        if($recipientlimit <= 0) {
            $retval[] = $item;
            return $retval;
        }
        for($i=0, $x=0; $i < sizeof($item); $i++) {
            if($x == 0) {
                $retval[] = array();
                $split = &$retval[sizeof($retval)-1];
            }
            $split[] = $item[$i];
            if(++$x >= $recipientlimit)
                $x = 0;
        }
        return $retval;
    }

    function Stripos (& $haystack, $needle, $offset = 0) {
        if(function_exists('stripos')) {
            return stripos($haystack,$needle,$offset);
        }
        // PHP 4 doesn't define this function
        preg_match('/'.str_replace('/','\/',$needle).'/i',$haystack,$matches,PREG_OFFSET_CAPTURE,1);
        if(!$matches || !$matches[0][1]) {
            return false;
        }
        return $matches[0][1];
    }

    function GetSingleBodyPart(&$mailbody,$part) {
        preg_match('/(.*)(\r|)\nContent-Type: '.str_replace('/','\/',$part).'/im',
            $mailbody,$matches,PREG_OFFSET_CAPTURE,1);
        if($matches[0][0]) {
            if($pos=strpos(substr($mailbody,$matches[0][1]),"\r\n\r\n")) {
                $pos+=4;
            } else {
                if($pos=strpos(substr($mailbody,$matches[0][1]),"\n\n")) {
                    $pos+=2;
                } else {
                    return false;
                }
            }
            $pos+=$matches[0][1];
            $nextpart=trim(strtok($matches[0][0],"\r\n"));
            // search for last 'NextPart' of this body part
            $last=strpos(substr($mailbody,$pos),$nextpart);
            return substr($mailbody,$pos,$last);
        }
        return false;
    }

    function ImplodeHeaders($headkey,$token) {
        $retval = '';
        if(!is_array($token)) {
            return $retval;
        }
        foreach($token as $key => $val) {
            if(!is_array($val)) {
                $retval.= (strcmp($headkey,'') ? $headkey : $key).' '.$val."\r\n";
            } else {
                $retval.= $this->ImplodeHeaders($key,$val);
            }
        }
        return $retval;
    }

    function GetReturnPath($address) {
        $retval = $address;

        if(!$this->decoded[0]['ExtractedAddresses'])
            return $retval;
        $headers = & $this->decoded[0]['ExtractedAddresses'];
        if(array_key_exists('return-path:',$headers)) {
            $retval =  $headers['return-path:'][0]['address'];
        } else if(!empty($headers['reply-to:'])) {
            $retval =  $headers['reply-to:'][0]['address'];
        }
        if(strlen($retval) == 0 || preg_match('/error|bounce|no(-|_|)reply/i',$retval)) {
            echo " got mailer address, no reply; ";
            if($this->debug) {
                $this->debugOutput .= "\nREPLY-TO ADDRESS ERROR: mailer\n";
            }
            return '';
        } else {
            return $retval;
        }
    }


    function SmtpSend($mailto, $mailsubject, $mailfrom, &$mailheader, &$mailbody) {
        $this->SmtpInit();

        if($this->smtp->direct_delivery)
        {
            if(!function_exists("GetMXRR"))
            {
                /*
                * If possible specify in this array the address of at least on local
                * DNS that may be queried from your network.
                */
                $_NAMESERVERS=array();
                include(SCRIPTS_DIR_PATH.DS."getmxrr.php");
            }
            /*
            * If GetMXRR function is available but it is not functional, to use
            * the direct delivery mode, you may use a replacement function.
            */
            /*
            else
            {
                $_NAMESERVERS=array();
                if(count($_NAMESERVERS)==0)
                    Unset($_NAMESERVERS);
                include(SCRIPTS_DIR_PATH.DS."rrcompat.php");
                $this->smtp->getmxrr="_getmxrr";
            }
            */
        }

        if($this->smtpDebug) {
            $this->smtp->debug = $this->smtpDebug;
            $this->debugOutput .= "\n\nSTARTING SMTP:\n";
            ob_start();
        } else if($this->debug) {
            $this->debugOutput .= "\nRCPT TO:\n".
                (is_array($mailto) ? implode("\n",$mailto) : $mailto)."\n\n$mailheader\n$mailbody";
            if($success=$this->smtp->Connect()) {
                $this->smtp->Disconnect();
                $retval = 'OK.';
                $this->debugOutput .= "\n\nSMTP CONNECTION STATUS: passed\n";
                return $retval;
            } else {
                $retval = $success;
                $this->debugOutput .= "\n\nSMTP CONNECTION STATUS: failed\n";
                return $retval;
            }
        }
        if($this->smtp->SendMessage($mailfrom,
                (is_array($mailto) ? $mailto : array($mailto)),
                explode("\n",$mailheader), $mailbody)) {
            $retval = "OK.";
        } else {
            $retval = $this->smtp->error;
        }
        if($this->smtpDebug) {
            $this->debugOutput .= "\n\n".ob_get_contents();
            ob_end_clean();
        }
        return $retval;
    }

    function GetText($def,$returndef = false) {
        $retval = false;

        if(!preg_match('/\[\[:'.$def.'=.*/im',$this->dbrow->language,$matches,PREG_OFFSET_CAPTURE)) {
            return ($returndef ? $def : $retval);
        }
        $start = $matches[0][1]+strlen($def)+4;
        if(!$end = strpos(substr($this->dbrow->language,$matches[0][1]),':]]')) {
            if(!$end = strpos(substr($this->dbrow->language,$pos),'[[:')) {
                return ($returndef ? $def : false);
            } else {
                $end -= -4;
            }
        } else {
            $end -= (strlen($def) + 4);
        }
            $retval = substr($this->dbrow->language,$start,$end);
        return $retval;
    }

    function NotifyUser($address,$digest,&$mailsubject,&$mailbody) {
        $mailheader = '';
        $digesttext = '';

        if($digest) {
            if(!$digesttext=$this->GetText('DIGEST MODE')) {
                $digesttext = "Digest Mode";
            }
        }
        $mailbody = $this->SetText($mailbody);
        $mailbody = str_replace("__DIGESTMODE__", $digesttext, $mailbody);

        // change the first header to send bounced emails/user reply to whatever you want
        // (ie. noreply@domain.com)
        $mailheader.="Return-Path: ".$this->listowner."\r\n";
        $mailheader.="Reply-To: ".$this->listaddress."\r\n";
        $mailheader.="To: ".$address."\r\n";
        $mailheader.="From: ".$this->listaddress."\r\nSubject: $mailsubject\r\n";
        $mailheader.= "Precedence: bulk\r\n";
        $error = $this->SmtpSend($address, $mailsubject, $this->listaddress, $mailheader, $mailbody);
        if($error != 'OK.') {
            $this->NotifyOwner($address,'User notification failed, ml ['.$this->listaddress.']',
                'Notification failure for ml ['.$this->listaddress.'] for address <'.$address."> smtp error [$error]");
        }
    }

    function NotifySubscriptionRequest($address,$digest,$mailbody) {
        if($digest) {
            if(!$digesttext=$this->GetText('DIGEST MODE')) {
                $digesttext = "Digest Mode";
            }
        }
        $mailsubject = $this->GetText('NOTIFY OWNER SUBSCRIBE MOD',true).'['.$this->listaddress."] <$address>";
            $mailbody = str_replace("__DIGESTMODE__", $digesttext, $mailbody);
        if(!$this->NotifyOwner($address,$mailsubject,$mailbody)) {
            return false;
        }
        return true;
    }

    function SendSubscribeConfirmation($address,$command,$digest = false,$msgcode = false, $modrequest = false) {
        //$subscribe = $this->GetText('SUBSCRIBE',true);
        $confirm = $this->GetText('CONFIRM',true);
        $toggle = $this->GetText('TOGGLE',true);

        $id = md5(uniqid(rand(), true));
        //$mailsubject = 'confirm subscribe to '.$this->listaddress;
        $mailsubject = "$confirm $command $this->listaddress";
        $mailbody = "__SUBSCRIBE__";
        $confirmtext = ($modrequest != false ? $modrequest.'.' : '').
            "$confirm.$command.".($digest ? 'digest.' : '').$this->listname.'.'.$id.'.'.$address;

        if(!$mailbody=$this->GetText(($msgcode != false ? $msgcode : 'SUBSCRIBE CONF'))) {
            $mailbody = "Please confirm subscription for <__SUBSCRIBE__> to <__LISTADDRESS__>  __DIGESTMODE__\r\n\r\nThanks.\r\n";
        }
        $mailbody = str_replace("__SUBSCRIBE__", $confirmtext,
        str_replace('__TOGGLE__',$toggle,$this->SetText($mailbody,$address)));

        if(!$this->debug) {
            $query="insert into $this->subqueue values ('".$this->listname.':'.
                ($modrequest != false ? $modrequest.'-' : '').
                "$address','subscription','$id',now(),'');";
            if(!@mysql_query($query,$this->dbconn)) { // there is another request, replace it
                $query="update ".$this->subqueue.
                " set request = 'subscription', keyvalue = '$id' where code = '".$this->listname.':'.
                ($modrequest != false ? $modrequest.'-' : '').
                "$address';";
                @mysql_query($query,$this->dbconn);
            }
        }
        if($modrequest != false) {
            if(!$this->NotifySubscriptionRequest($address,$digest,$mailbody)) {
                return false;
            }
        } else {
            if(!$this->NotifyUser($address,$digest,$mailsubject,$mailbody)) {
                return false;
            }
        }
    }

    function SendWelcomeMessage($address,$digest, $msgcode = false, $password = '') {
        //$mailsubject = 'WELCOME to '.$this->listaddress;
        $mailsubject = $this->GetText('WELCOME',true).$this->listaddress;
        $mailbody  = '';

        if(!$mailbody=$this->GetText(($msgcode == false ? 'SUBSCRIBE WELCOME' : $msgcode))) {
            $mailbody = "The address <__SUBSCRIBE__> has been added to <__LISTADDRESS__> __DIGESTMODE__\r\n\r\nThanks.\r\n";
        }
        $mailbody = str_replace('__SUBSCRIBE__', $address, $mailbody);
        $mailbody = str_replace('__USERPASS__',
            (strlen($password) > 1 ? "[$password]" : $this->GetText('USERPASS SET')), $mailbody);
            
        if(!$this->NotifyUser($address,$digest,$mailsubject,$mailbody)) {
            return false;
        }
    }

    function ToggleAddress($address) {
        $digest = false;
        if(preg_match('/(^|\n)'.$address.'(\n|$)/i',$this->dbrow->sublist)) {
            $this->dbrow->sublist=preg_replace("/(^|\n)$address(\n|$)/",'\1',
                trim($this->dbrow->sublist));
            $this->dbrow->digestsublist=trim($this->dbrow->digestsublist)."\n".$address;
            $digest = true;
        } else {
            $this->dbrow->digestsublist=preg_replace("/^|\n)$address(\n|$)/",'\1',
                trim($this->dbrow->digestsublist));
            $this->dbrow->sublist=trim($this->dbrow->sublist)."\n".$address;
        }
        $query = 'update '.$this->mltable.' set sublist = \''.trim($this->dbrow->sublist).'\', digestsublist = \''.
            trim($this->dbrow->digestsublist).'\' where listname = \''.$this->listname.'\'';
        if($command = @mysql_query($query,$this->dbconn)) {
            echo "toggled address [$address]\n";
            $this->SendWelcomeMessage($address,$digest,'TOGGLED MESSAGE');
        }
    }

    function SetConfirmedAddress($address, $digest = false) {
        $sql = 'sublist';

        if($digest) {
            $this->dbrow->digestsublist=trim($this->dbrow->digestsublist)."\n".$address;
            $sublist = &$this->dbrow->digestsublist;
            $sql = 'digestsublist';
        } else {
            $this->dbrow->sublist=trim($this->dbrow->sublist)."\n".$address;
            $sublist = &$this->dbrow->sublist;
            $sql = 'sublist';
        }
        $query = 'update '.$this->mltable.' set '.$sql.' = \''.
            trim($sublist).'\' where listname = \''.$this->listname.'\'';
        if(!$command = @mysql_query($query,$this->dbconn)) {
            return;
        }
        echo "confirmed subscription [$address]\n";
        // check if subscriber is register yet, otherwise write a new record
        $query = 'select count(*) from '.$this->subscribers." where emailaddress = '$address'";
        if($result = @mysql_query($query,$this->dbconn)) {
            $row = @mysql_fetch_row($result);
            if($row[0] <= 0) {
                require_once(CLASSES_DIR_PATH.DS.'class.genpass.php');
                $password = GenPass::CreatePassword(8);
                $query = 'insert into '.$this->subscribers.
                    " (id,emailaddress,state,webpass,rowlock) values (0,'$address','enabled',password('".
                    $password."'),'')";
                @mysql_query($query,$this->dbconn);
                $this->SendWelcomeMessage($address,$digest,'SUBSCRIBE WELCOME',$password);
            } else {
                $this->SendWelcomeMessage($address,$digest);
            }
            @mysql_free_result($result);
            return;
        }
        $this->SendWelcomeMessage($address,$digest);
    }

    function SendSubscriptionError($address,$digest,$errorcode) {
        if(strlen($address) < 7)
            return;
        $mailsubject = $this->GetText('NOTIFY SUBJECT',true).' '.$this->listaddress;
        $mailheader = '';
        $mailbody  = '';

        if(!$mailbody=$this->GetText($errorcode)) {
            $mailbody = "Subscription error for address <__UNSUBSCRIBE__>, list <__LISTADDRESS__> __DIGESTMODE__\r\n\r\n";
        }
        $mailbody = str_replace("__UNSUBSCRIBE__", $address, $this->SetText($mailbody));
        $this->NotifyUser($address,$digest,$mailsubject,$mailbody);
        echo " subscription error for address [$address] to list [$this->listname] code [$errorcode];\n";
    }

    function IsSubscription(&$bodytest, $address, & $substate) {
        $toggle = $this->GetText('TOGGLE',true);
        $subscribe = $this->GetText('SUBSCRIBE',true);
        $confirm = $this->GetText('CONFIRM',true);
        $owner = $this->GetText('OWNER',true);

        $digest = eregi("digest",$bodytest);
        if(eregi("^".$toggle,ltrim($bodytest," <>"))) {
            if($this->debug) $this->debugOutput .= "\nGot command: TOGGLE\n";
            if(!strcmp($substate,'subscribeddigest')                 // both subscriptions
            || (!strstr($substate,'subscribed') && !strstr($substate,'digest'))) {    // no subscription
                $this->SendSubscriptionError($address,$digest,'TOGGLE ERROR STATE');
                return true;
            }
            if(strcasecmp($this->dbrow->confirmsub,'yes')) {
                $this->ToggleAddress($address);
            } else {
                $this->SendSubscribeConfirmation($address,$toggle,false,'TOGGLE CONF');
                echo "toggle [$address]. require confirmation: ";
            }
            return true;
        } else if(eregi("^".$subscribe,ltrim($bodytest," <>"))) {
            // got "subscribe" command, check if user already exists
            if($this->debug) $this->debugOutput .= "\nGot command: SUBSCRIBE\n";
            // if user exists in digest mode, ignore request
            if($digest && strstr($substate,'digest')) {
                $this->SendSubscriptionError($address,$digest,'SUBSCRIPTION ERROR STATE');
                return true;
            }
            // if user exists in normal mode, need to toggle subscription
            if($digest && !strcmp($substate,'subscribed')) {
                $this->SendSubscribeConfirmation($address,$subscribe,$digest,'SUBSCRIPTION ERROR MODE');
                return true;
            }
            // if user exists in normal mode, ignore request
            if(!$digest && !strcmp($substate,'subscribed')) {
                $this->SendSubscriptionError($address,$digest,'SUBSCRIPTION ERROR STATE');
                return true;
            }
            // if user exists in digest mode, need to toggle subscription
            if(!$digest && strstr($substate,'digest')) {
                $this->SendSubscribeConfirmation($address,$subscribe,$digest,'SUBSCRIPTION ERROR MODE');
                return true;
            }
            /* no user, normal subscription request */
            if(strcasecmp($this->dbrow->confirmsub,'yes')) {
                $this->SetConfirmedAddress($address,$digest);
            } else {
                echo "subscribe [$address]. require confirmation: ";
                $this->SendSubscribeConfirmation($address,$subscribe,$digest);
            }
            return true;
        }
        // if preg failed it's not a subscription request
        if(!preg_match('/(\b'.$owner."\b|).\b$confirm\b.\b($subscribe|$toggle)\b.".$this->listname.
                "\.([A-Za-z0-9]+)\.(.*)/i", $bodytest, $matches,PREG_OFFSET_CAPTURE)) {
            return false;
        }
        $originaladdress = false;
        if(strlen($matches[1][0]) > 1 && !strcasecmp($owner,$matches[1][0])) {
            if(!$pos = strpos($matches[4][0],'>')) {
                if(!$pos = strpos($matches[4][0],' ')) {
                    return false;
                }
            }
            $originaladdress = rtrim(substr($matches[4][0],0,$pos));
            $query = "select * from ".addslashes($this->subqueue)." where code = '".
                $this->listname.":$owner-$originaladdress' and request = 'subscription'";
        } else {
            $query = "select * from ".addslashes($this->subqueue)." where code = '".
                $this->listname.':'.$address."' and request = 'subscription'";
        }
        $command = @mysql_query($query,$this->dbconn);
        if(!$result = @mysql_fetch_object($command)) {
            return false;
        }
        if($matches[3][0] && strcmp($matches[3][0],$result->keyvalue)) {
            return false;
        }
        $query = "delete from ".addslashes($this->subqueue)." where code = '".
            $this->listname.':'.
            ($originaladdress != false ? "$owner-$originaladdress" : $address).
            "' and request = 'subscription'";
        if(!$this->debug) {
            $command = @mysql_query($query,$this->dbconn);
        }
        if(!strcasecmp($this->dbrow->subscriptionmod,'yes') && !eregi($owner,$matches[0][0])) {
            echo "subscription confirmed [$address]. require owner confirmation: ";
            $this->SendSubscribeConfirmation($address,$subscribe,$digest,'MOD SUBSCRIBE CONF',$owner);
            return true;
        }
        if(eregi($toggle,$this->decoded[0]['Body'])) {
            $this->ToggleAddress($originaladdress ? $originaladdress : $address);
        } else {
            $this->SetConfirmedAddress($originaladdress ? $originaladdress : $address,$digest);
        }
        return true;
    }

    function SendUnsubscribeConfirmation($address, $digest = false, $msgcode = false) {
        $unsubscribe = $this->GetText('UNSUBSCRIBE',true);
        $confirm = $this->GetText('CONFIRM',true);
        $toggle = $this->GetText('TOGGLE',true);
        $id = md5(uniqid(rand(), true));
        $mailsubject = "$confirm $unsubscribe $this->listaddress";
        $mailbody = "__UNSUBSCRIBE__";
        $confirmtext = "$confirm.$unsubscribe.".($digest ? 'digest.' : '').$this->listname.'.'.$id.'.'.$address;

        if(!$mailbody=$this->GetText(($msgcode != false ? $msgcode : 'UNSUBSCRIBE CONF'))) {
            $mailbody = "Please confirm unsubscription for <__SUBSCRIBE__> to <__LISTADDRESS__>  __DIGESTMODE__\r\n\r\nThanks.\r\n";
        }
        $mailbody = str_replace("__UNSUBSCRIBE__", $confirmtext, 
                str_replace("__TOGGLE__", $toggle, $this->SetText($mailbody,$address)));

        $query="insert into $this->subqueue values ('".$this->listname.":$address','unsubscription','$id',now(),'');";
        if(!@mysql_query($query,$this->dbconn)) { // there is another request, replace it
            $query="update ".$this->subqueue." set request = 'unsubscription', keyvalue = '$id' where code = '".
            $this->listname.":$address';";
            @mysql_query($query,$this->dbconn);
        }

        if(!$this->NotifyUser($address,$digest,$mailsubject,$mailbody)) {
            return false;
        }
    }

    function SendGoodbyeMessage($address,$digest) {
        $mailsubject = $this->GetText('GOODBYE',true).$this->listaddress;
        $mailheader = '';
        $mailbody  = '';

        if(!$mailbody=$this->GetText('UNSUBSCRIBE GOODBYE',true)) {
            $mailbody = "The address <__SUBSCRIBE__>, has been removed from <__LISTADDRESS__> DIGESTMODE__\r\n\r\nThanks.\r\n";
        }
        $mailbody = str_replace("__UNSUBSCRIBE__", $address, $this->SetText($mailbody));
        //$mailbody = str_replace("__DIGESTMODE__", $digesttext, $mailbody);
        $this->NotifyUser($address,$digest,$mailsubject,$mailbody);
    }

    function SendUnsubscriptionError($address,$digest,$errorcode) {
        $mailsubject = $this->GetText('NOTIFY SUBJECT',true).' '.$this->listaddress;
        $mailheader = '';
        $mailbody  = '';
        //$digesttext = '';

        if(!$mailbody=$this->GetText($errorcode)) {
            $mailbody = "The address <__UNSUBSCRIBE__>, is subscribed to list <__LISTADDRESS__> __DIGESTMODE__\r\n\r\nThanks.\r\n";
        }
        $mailbody = str_replace("__UNSUBSCRIBE__", $address, $this->SetText($mailbody));
        $this->NotifyUser($address,$digest,$mailsubject,$mailbody);
        echo " unsubscription error for address [$address] to list [$this->listname];\n";
    }

    function UnsetRegisteredAddress($address, $digest = false) {
        $sql = 'sublist';

/** DISABLED ***********************************
 * if you want to remove both "unsubscription" requests (normal mode/digest mode), enable rows below
        $this->dbrow->digestsublist=preg_replace("/(^|\n)$address(\n|$)/",'\1',
            trim($this->dbrow->digestsublist));
        $this->dbrow->sublist=preg_replace("/(^|\n)$address(\n|$)/",'\1',trim($this->dbrow->sublist));
        $query = 'update '.$this->mltable.' set sublist= \''.
            trim($this->dbrow->sublist).'\', digestsublist = \''.
            trim($this->dbrow->digestsublist).'\' where listname = \''.$this->listname.'\'';
************************************************/
        if($digest) {
            $this->dbrow->digestsublist=preg_replace("/(^|\n)$address(\n|$)/",'\1',
                trim($this->dbrow->digestsublist));
            $sublist = &$this->dbrow->digestsublist;
            $sql = 'digestsublist';
        } else {
            $this->dbrow->sublist=preg_replace("/(^|\n)$address(\n|$)/",'\1',trim($this->dbrow->sublist));
            $sublist = &$this->dbrow->sublist;
            $sql = 'sublist';
        }
        $query = 'update '.$this->mltable.' set '.$sql.' = \''.
            trim($sublist).'\' where listname = \''.$this->listname.'\'';
        if($command = @mysql_query($query,$this->dbconn)) {
            echo "confirmed unsubscription [$address]\n";
            $this->SendGoodbyeMessage($address,$digest);
        }
    }

    function IsUnsubscription(& $bodytest, $address, & $substate) {
        $error = '';

        $unsubscribe = $this->GetText('UNSUBSCRIBE',true);
        $confirm = $this->GetText('CONFIRM',true);

        $digest = eregi("digest",preg_replace("/\n|\r|=/",'',$bodytest));
        if(eregi("^".$unsubscribe,preg_replace("/\n|\r|=/",'',$bodytest))) {
            if($this->debug) $this->debugOutput .= "\nGot command: UNSUBSCRIBE\n";
            // if user exists in normal mode, need to toggle subscription
            if($digest && !strcmp($substate,'subscribed')) {
                $this->SendUnsubscriptionError($address,$digest,'UNSUBSCRIPTION ERROR STATE');
                return true;
            }
            // if user doesn't exist in digest mode, ignore request
            if($digest && !strstr($substate,'digest')) {
                $this->SendUnsubscriptionError($address,$digest,'UNSUBSCRIPTION ERROR STATE');
                return true;
            }
            // if user exists in digest mode, need to toggle subscription
            if(!$digest && strstr($substate,'digest')) {
                $this->SendUnsubscriptionError($address,$digest,'UNSUBSCRIPTION ERROR MODE');
                return true;
            }
            // if user doesn't exist in normal mode, ignore request
            if(!$digest && strcmp($substate,'subscribed')) {
                $this->SendUnsubscriptionError($address,$digest,'UNSUBSCRIPTION ERROR STATE');
                return true;
            }
            // got user, normal unsubscription request
            if(strcasecmp($this->dbrow->confirmunsub,'yes')) {
                $this->UnsetRegisteredAddress($address,$digest);
            } else {
                echo "unsubscribe [$address]. require confirmation\n";
                $this->SendUnsubscribeConfirmation($address,$digest);
            }
            return true;
        }
        $query = "select * from ".addslashes($this->subqueue)." where code = '".
            $this->listname.':'.$address."' and request = 'unsubscription'";
        $command = @mysql_query($query,$this->dbconn);
        if(!$result = @mysql_fetch_object($command)) {
            return false;
        }
        $error = "[$address] unsubscription request pending, ";
        echo $error;
        if(!eregi($confirm.'.*'.$unsubscribe.'.*'.$this->listname.'.*'.$result->keyvalue.'.*'.$address,
                preg_replace("/\n|\r|=/",'',$this->decoded[0]['Body']))) {
            if($this->debug) $this->debugOutput .= "\nGot unsubscription error: $error\n";
            $this->SendUnsubscriptionError($address,$digest,'UNSUBSCRIPTION PENDING');
            return true;
        }
        $query = "delete from ".addslashes($this->subqueue)." where code = '".
            $this->listname.':'.$address."' and request = 'unsubscription'";
        $command = @mysql_query($query,$this->dbconn);
        $this->UnsetRegisteredAddress($address,$digest);
        return true;
    }

    function RemoveMessage($message) {
        $this->error = '';
    
        if(!$this->debug) {
            $this->error=$this->pop3->DeleteMessage($message);
        }
        return true;
    }

    function NotifyMessageModeration($address) {
        $id = md5(uniqid(rand(), true));
        $mailheader = '';
        $mailsubject = $this->GetText('NOTIFY OWNER MESSAGE MOD',true)."[$this->listaddress] <$address>";
        $confirmtext = $this->GetText('CONFIRM',true).'.'.
            $confirm.$this->GetText('MESSAGE',true).".$this->listname.$id.$address";

        if(!$mailbody=$this->GetText('MOD MESSAGE CONF')) {
            $mailbody = "Please confirm message moderation for <__SUBSCRIBE__> to <__LISTADDRESS__>\r\n\r\nThanks.\r\n";
        }
        $mailbody = str_replace("__MESSAGEID__", $confirmtext, $this->SetText($mailbody));

        echo 'message moderation for ml owner from <'.$address.">;\n";
        $boundary='----NextPart'.md5(date('r', time()));
        $mailheader.="From: ".$this->listaddress."\r\nMIME-Version: 1.0\r\nContent-Type: multipart/report; boundary=".
            $boundary."\r\n";
        $mailheader.='Subject: '.$mailsubject."\r\n";
        $mailbody ='--'.$boundary."\r\nContent-Type: text/plain; charset: us-ascii\r\n\r\n".
            $mailbody."\r\noriginal message:\r\n\r\n";
        $mailbody.='--'.$boundary."\r\nContent-Type: message/rfc822\r\nContent-Disposition: inline; filename=\"msg.eml\"\r\n\r\n".str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers']))."\r\n".str_replace("'","\\'",$this->decoded[0]['Body'])."\r\n\r\n".'--'.$boundary."--\r\n\r\n";
        $error = $this->SmtpSend(explode("\n",$this->modsublist), $mailsubject, $this->listaddress, $mailheader, $mailbody);
        if($error != 'OK.') {
            echo "owner notify failed [$error]";
            return;
        }
        $query = "insert into ".$this->messagesTable.
            " (id,mldate,state,mltable,smtp,mailfrom,subject,message,header,keyvalue,rowlock) values(0,now(),'".
            "pending','$this->listname','$this->smtpindex','$address','".
            str_replace("'","\\'",$this->decoded[0]['Headers']['subject:'])."','".
            str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers']).
            "\r\n\r\n".$this->decoded[0]['Body'])."','".
            str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers']))
            // enable it if you want the md5 value into header too
            // ."X-OriginalModerationID: $id\r\n'
            ."','$id','')";
        if(!$command = @mysql_query($query,$this->dbconn)) {
            echo "inserting message into table failed; [".mysql_error()."]\n";
        }
    }

    function NotifyOwner($address, $mailsubject = false, $mailbody = '') {
        $id = md5(uniqid(rand(), true));
        $mailheader = '';
        if(!$mailsubject)
            $mailsubject = 'Owner request for ['.$this->listname.'] from <'.$address.'>';

        if(strlen($mailbody) <= 0)
            $mailbody = $mailsubject;
        echo 'message for ml owner from <'.$address.">;\n";
        $boundary='----NextPart'.md5(date('r', time()));
        // change the first header to not send bounced emails to list again and avoid looping
        // i'm using the same domain of pop3 ml account
        // you can also use an empty value for it:
        // Return-Path:
        $mailheader.="Return-Path: no-reply".substr($this->listaddress,strpos($this->listaddress,'@')).
            "\r\nPrecedence: bulk\r\n";
        $mailheader.="From: ".$this->listaddress."\r\nMIME-Version: 1.0\r\nContent-Type: multipart/report; boundary=".
            $boundary."\r\n";
        $mailheader.='Subject: '.$mailsubject."\r\n";
        $mailbody ='--'.$boundary."\r\nContent-Type: text/plain; charset: us-ascii\r\n\r\n".
            $mailbody."\r\n\r\noriginal message:\r\n\r\n";
        $mailbody.='--'.$boundary.
            "\r\nContent-Type: message/rfc822\r\nContent-Disposition: inline; filename=\"msg.eml\"\r\n\r\n".
            str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers']))."\r\n".
            str_replace("'","\\'",$this->decoded[0]['Body'])."\r\n\r\n".'--'.$boundary."--\r\n\r\n";
        $error = $this->SmtpSend($this->listowner, $mailsubject, $this->listaddress, $mailheader, $mailbody);
        if($error != 'OK.') {
            echo "owner notify failed [$error]";
            return;
        }
    }

    function NotifyBounce($messageid,$bounceerror) {
        $id = md5(uniqid(rand(), true));
        $mailheader = '';
        $mailbody = '';
        $mailsubject = 'Delivery Status Notification (Failure) for ['.$this->listname.']';

        echo "bouncing for message [$messageid] errors [$bounceerror];\n";
        $query = "select * from $this->messagesTable where id = $messageid";
        if(!$result = @mysql_query($query,$this->dbconn)) {
            return;
        }
        if(!$row = @mysql_fetch_object($result)) {
            return;
        }
        $boundary='----NextPart'.md5(date('r', time()));
        $mailheader.="Return-Path: no-reply".substr($this->listaddress,strpos($this->listaddress,'@')).
            "\r\nPrecedence: bulk\r\n";
        $mailheader.="From: ".$this->listaddress."\r\nMIME-Version: 1.0\r\nContent-Type: multipart/report; boundary=".
            $boundary."\r\n";
        $mailheader.='Subject: '.$mailsubject."\r\n";
        $mailbody.='--'.$boundary."\r\nContent-Type: text/plain; charset: us-ascii\r\n\r\n".
            "bounce error for:\r\n\r\n$bounceerror\r\n\r\n";
        $mailbody.='--'.$boundary.
            "\r\nContent-Type: message/rfc822\r\nContent-Disposition: inline; filename=\"msg.eml\"\r\n\r\n".
            $row->message."\r\n\r\n";
        $mailbody.='--'.$boundary."--\r\n\r\n";
        $error = $this->SmtpSend($this->listowner, $mailsubject, $this->listaddress, $mailheader, $mailbody);
        if($error != 'OK.') {
            echo "owner notify failed [$error]";
            return;
        }
        @mysql_free_result($result);
    }

    function BounceMessage($sender,$badaddress,$action='Failed',$status='5.1.1',$diagcode='550 5.1.1 User unknown') {
        $id = md5(uniqid(rand(), true));
        $mailheader = '';
        $mailbody = '';
        $mailsubject = 'Delivery Status Notification (Failure) for ['.$this->listname.']';

        $boundary='----NextPart'.md5(date('r', time()));
        $mailheader.="Return-Path:\r\nPrecedence: bulk\r\n";
        $mailheader.="From: ".$this->listaddress."\r\nMIME-Version: 1.0\r\nContent-Type: multipart/report; boundary=".
            $boundary."\r\n";
        $mailheader.='Subject: '.$mailsubject."\r\n";
        $mailbody.='--'.$boundary."\r\nContent-Type: text/plain; charset: us-ascii\r\n\r\n".
            "bounce error:\r\n\r\nSender: $sender\r\nAddress: $badaddress\r\nAction: $action\r\nStatus: $status\r\nDiagnostic code: $diagcode\r\n\r\n";
        $mailbody.='--'.$boundary.
            "\r\nContent-Type: message/rfc822\r\nContent-Disposition: inline; filename=\"msg.eml\"\r\n\r\n".
            $this->ImplodeHeaders('',$this->decoded[0]['Headers'])."\r\n\r\n".$this->decoded[0]['Body']."\r\n\r\n";
        $mailbody.='--'.$boundary."--\r\n\r\n";
        $error = $this->SmtpSend($this->listowner, $mailsubject, $this->listaddress, $mailheader, $mailbody);
        if($error != 'OK.') {
            echo "owner notify failed [$error]";
            return;
        }
        /*
        * check if there are queued messages with this badaddress
        */
        $query = "select * from $this->queue where addresses REGEXP '(^|,)$badaddress(,|$)'";
        if(!$result = @mysql_query($query,$this->dbconn)) {
            return;
        }
        while($row = @mysql_fetch_object($result)) {
            /*
            * if there is badaddress only, remove queuerecord and set message state to 'sent'
            */
            if(!strcmp(trim($row->addresses),$badaddress)) { 
                @mysql_query('update '.$this->messageTable.
                    ' set state = \'sent\' where id = '.$row->messageid,$this->dbconn);
                @mysql_query('delete from '.$this->queue.
                    ' where id = '.$row->id,$this->dbconn);
                continue;
            }
            /*
            * there are more then one address, remove it and update queue record
            */
            $row->addresses = preg_replace("/(^|,)$badaddress(,|$)/",'\1',$row->addresses);
            $row->addresses = trim($row->addresses,"\r\n, ");
            @mysql_query('update '.$this->queue." set addresses = '$row->addresses'",$this->dbconn);
        }
        @mysql_free_result($result);
    }

    function CheckBounce() {
        $address = & $this->decoded[0]['ExtractedAddresses']['from:'][0]['address'];
        if(!$address)
            return;
        $mailbody= & $this->decoded[0]['Body'];
        // check for gmail first
        if(preg_match('/(google|gmail)/i',$address)) {
            if($pos=$this->Stripos($mailbody,"Delivery to the following recipient failed permanently:")) {
                $pos+=57;    // text plus "\r\n" or "\n\n"
                if(!$end=strpos(substr($mailbody,$pos+4),"\r\n\r\n")) {
                    if(!$end=strpos(substr($mailbody,$pos+4),"\n\n")) {
                        return;    // no match
                    }
                }
                $badaddress = trim(substr($mailbody,$pos,$end+4));
                $this->BounceMessage($address,$badaddress,'failed','5.1.1','550 5.1.1 User unknown');
                return;
            }
        }
        //$this->header = & $this->decoded[0]
        if(!$pos = $this->stripos($mailbody,'Content-Type: message/delivery-status')) {
            return;
        }
        if($this->decoded[0]['Headers']['content-type:']
        && eregi('multipart\/report.*report-type=delivery-status',$this->decoded[0]['Headers']['content-type:'])) {
            if(preg_match('/Final-Recipient:[[:space:]]+(rfc822;|)[[:space:]]+.*(\r|\n)/i',
                        substr($mailbody,$pos),$matches,PREG_OFFSET_CAPTURE)) {
                $pos = strrpos($matches[0][0]," ");
                $badaddress = trim(substr($matches[0][0],$pos+1));
                $pos = $matches[0][1];
                if(preg_match('/Action:[[:space:]]+.*(\r|\n)/i',
                        substr($mailbody,$pos),$matches,PREG_OFFSET_CAPTURE)) {
                    $action = trim(substr($matches[0][0],strrpos($matches[0][0]," ")+1));
                }
                if(preg_match('/Status:[[:space:]]+.*(\r|\n)/i',
                        substr($mailbody,$pos),$matches,PREG_OFFSET_CAPTURE)) {
                    $status = trim(substr($matches[0][0],strrpos($matches[0][0]," ")+1));
                }
                if(preg_match('/Diagnostic-Code:.*(\r|\n)/i',
                        substr($mailbody,$pos),$matches,PREG_OFFSET_CAPTURE)) {
                    $diagcode = trim(substr($matches[0][0],strlen('Diagnostic-Code: ')));
                }
                if(strlen($badaddress) >= 10) {
                    echo "badaddress: $badaddress\n";
                    $this->BounceMessage($address,$badaddress,
                        ($action ? $action : ''),
                        ($status ? $status : ''),
                        ($diagcode ? $diagcode : ''));
                }
            }
        }
    }

    /**
     * PASSWORD command to set subscribers password for web access to all ML email messages
     * syntax: password OldPassword NewPassword
     */
    function SetUserPassword($address, $body) {
        $list = null;    // array for messages list
        $get = $this->GetText('GET',true);
        $mailsubject = $this->GetText('NOTIFY SUBJECT', true)." $this->listaddress";
        $mailbody = $this->GetText('GENERIC ERROR',true);

        $cmd = strtok($body," \r\n\t");
        $oldpw = strtok(' ');
        $newpw = strtok(" \r\n\t");
        $query = "select *,password('$oldpw') as oldpw from ".$this->subscribers." where emailaddress = '$address'";
        if(!$result = @mysql_query($query,$this->dbconn)) {
            $this->NotifyUser($address,false,$mailsubject,$mailbody);
            return;
        }
        if(!$row = @mysql_fetch_row($result)) {
            @mysql_free_result($result);
            $this->NotifyUser($address,false,$mailsubject,$mailbody);
            return;
        }
        $pwmatch = strcmp($row[2],$row[4]);
        @mysql_free_result($result);
        if($pwmatch == 0) {    // match with old password
            $query = 'update '.$this->subscribers." set webpass = password('$newpw') where emailaddress = '$address'";
            if(!$this->debug) {
                $result = @mysql_query($query,$this->dbconn);
            } else {
                $result = true;
            }
            if($result) {
                $mailbody = $this->GetText('USERPASS CHANGED',true)."\n$newpw";
            }
            echo "changed password for [$address]; ";
        } else {
            $mailbody = $this->GetText('USERPASS WRONG',true);
            echo "wrong password for [$address] changing request; ";
        }
        $this->NotifyUser($address,false,$mailsubject,$mailbody);
    }

    /**
     * GET command:
     * get 1        // to retrieve message 1
     * get 1,2,3        // to retrieve 1,2 and 3 message
     * get 1,2,5-10,11    // to retrieve 1,2,from 5 to 10 and 11 message
     */
    function GetCommand($address, $body) {
        $list = null;    // array for messages list
        $get = $this->GetText('GET',true);

        $body = trim($body,"\n\r ,.<>");
        $bodytest = trim(substr($body,strlen($get)+1),"\n\r ,.<>");

        if(strlen($bodytest) < 1)
            return;
        if(strstr($bodytest,',')) {        // request for specific message(s) ie. 'get 1,4,10'
            $list = explode(',',$bodytest);
        } else {
            $list[] = &$bodytest;
        }
        $query = "select * from $this->messagesTable where state = 'sent' and ";
        foreach($list as $request) {
            $token = explode('-',$request);
            $query .=
                (sizeof($token) == 1 ?
                    ('id = '.$token[0])
                :
                    ('(id >= '.$token[0].' and id <= '.$token[1]).')');
            $query .= ' or ';
        }
        if(!$result=@mysql_query(substr($query,0,-4),$this->dbconn)) {
            return false;
        }
        $mailsubject = 'Subject: '.$this->listname.': '.$body;
        $mailheader = '';
        $mailbody = '';
        $boundary = '';
        $messagelist = '';

        // foreach($this->headersadd as $hk => $hv) { if(strcmp($hv,'')) { $mailheader.= $hk.': '.$hv."\r\n"; } }
        $mailheader.= "Return-Path: ".$this->listowner."\r\n";
        $mailheader.= "Precedence: bulk\r\n";
        $boundary='----NextPart'.md5(date('r', time()));
        $mailheader.="From: ".$this->listaddress."\r\nMIME-Version: 1.0\r\nContent-Type: multipart/digest; boundary=".
            $boundary."\r\n";

        $mailbody.='--'.$boundary."\r\nContent-Type: text/plain; charset: us-ascii\r\n\r\n".
            $this->listname." $body:\r\n\r\n";

        echo 'get request response for # '.$body."; ";
        while($row = @mysql_fetch_object($result)) {
            $mailbody.="Id: ".$row->id."\r\nSender: ".$row->mailfrom."\n\nSubject: ".$row->subject."\r\n";
            $messagelist.='--'.$boundary.
                "\r\nContent-Type: message/rfc822\r\nContent-Disposition: inline; filename=\"msg".$row->id.".
                eml\"\r\n\r\n".$row->message."\r\n\r\n";
            $mailbody.="\r\n\r\n";
        }
        @mysql_free_result($result);
        $mailheader.=$mailsubject;
        $mailbody.=$messagelist.'--'.$boundary."--\r\n\r\n";
        unset($messagelist);
        $error = $this->SmtpSend($address,$mailsubject,$this->listaddress,$mailheader,$mailbody);
        if($error != 'OK.') {
            echo " get-error [$error] for [$mailaddress];";
        }
        return;
    }

    function CheckMlCommand($address, & $substate) {
        if(!$bodytest=$this->GetSingleBodyPart($this->decoded[0]['Body'],'text/plain')) {
            $bodytest = & $this->decoded[0]['Body'];
        }
        if(eregi("^".$this->GetText('GET',true),ltrim($bodytest,"\r\n <>"))) {
            if($this->debug) $this->debugOutput .= "\nGot command: GET\n";
            $this->GetCommand($address,$bodytest);
            return true;
        } else if(eregi("^".$this->GetText('NOTIFY OWNER',true),ltrim($bodytest,"\r\n <>"))) {
            if($this->debug) $this->debugOutput .= "\nGot command: NOTIFY OWNER\n";
            $this->NotifyOwner($address);
            return true;
        } else if(eregi("^".$this->GetText('HELP',true),ltrim($bodytest,"\r\n <>"))) {
            if($this->debug) $this->debugOutput .= "\nGot command: HELP\n";
            $this->NotifyUser($address,false,
                $this->GetText('HELP SUBJECT',true),$this->GetText('HELP MESSAGE',true));
            return true;
        } else if(eregi("^PASSWORD",ltrim($bodytest,"\r\n <>"))) {
            if($this->debug) $this->debugOutput .= "\nGot command: PASSWORD\n";
            $this->SetUserPassword($address,$bodytest);
            return true;
        }
        $bodytest = preg_replace("/\n|\r|=/",'',$bodytest);
        if($this->IsSubscription($bodytest, $address,$substate) == true) {
            return true;
        }
        if($this->IsUnsubscription($bodytest, $address,$substate) == true) {
            return true;
        }
        // no ml command
        $this->bodytextplain = & $bodytest;
        return false;
    }

    /**
     *  return values:
     *  'deny' -> no access to ML
     *  'subscribed' -> address exists into 'sublist' field (or ml is not configured for subscribers only)
     *  'digest' -> address exists into 'digestsublist' field
     *  'subscribeddigest' -> address exists into both 'sublist/digestsublist' fields
     *  'allow' -> address exists into 'allow' field
     *  'mailer' -> it's automatic mailer
     *  'moderator' -> moderator or owner address
     */
    function CheckSender($address) {
        $retval = 'deny';

        if(!$address || strlen($address) < 7) {    // invalid sender, ignore email
            return $retval;
        }
        if(class_exists('Bouncehandler')) {
            $head = str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers']));
            $body = str_replace("'","\\'",$this->decoded[0]['Body']);
            $multiArray = Bouncehandler::get_the_facts($head."\r\n".$body);
            if(!empty($multiArray['recipient'])) {    // email bounced, notify owner
                $this->BounceMessage($address,$multiArray[0]['recipient'],
                            $multiArray[0]['action'],
                            $multiArray[0]['status'],
                            $multiArray[0]['status']);
                return 'mailer';
            }
            // make a specific body test
            $head_hash = BounceHandler::parse_head($head);
            $boundary = $head_hash['Content-type']['boundary'];
            $mime_sections = BounceHandler::parse_body_into_mime_sections($body, $boundary);
            $rpt_hash=BounceHandler::parse_machine_parsable_body_part($mime_sections['machine_parsable_body_part']);
            for($i=0; $i<count($rpt_hash['per_recipient']); $i++){    
                if(!empty($rpt_hash['per_recipient'][$i]['Action'])) {
                    $this->BounceMessage($address,
                        implode(", ",$rpt_hash['per_recipient'][$i]['Final-recipient']),
                        $rpt_hash['per_recipient'][$i]['Action'],
                        $rpt_hash['per_recipient'][$i]['Status'],
                        $rpt_hash['per_recipient'][$i]['X-supplementary-info']);
                    return 'mailer';
                }
            }
        } else if(preg_match('/(mailer-daemon|majordomo|virus|scanner|automated-response|smtp[.-]gateway|mailadmin|mailmaster|surfcontrol|postmaster|no(-|)reply|nobody|devnull)/i',
                $this->decoded[0]['ExtractedAddresses']['from:'][0]['address'])
        || preg_match('/auto(_|-|)reply/i',$this->decoded[0]['Headers']['precedence:'])) {
            $this->CheckBounce();
            return 'mailer';
        }
        // be sure it's not an undetected autoresponder (ie. 'From: "Gmail Team" <mail-noreply@gmail.com>')
        if(isset($this->decoded[0]['Headers']['precedence:'])
                && eregi('(bulk|junk)',$this->decoded[0]['Headers']['precedence:'])
        || preg_match('/no(-|_|)reply/i',
                $this->decoded[0]['ExtractedAddresses']['from:'][0]['address'])) {
            return 'mailer';
        }
        if(!strcmp($address,$this->listowner)
        || eregi("(^|\n)$address(\n|$)",$this->modsublist)) {
            return 'moderator';
        }
        if(is_array($this->allow)) {
            foreach($this->allow as $pattern) {
                if(eregi($pattern, $address)) {
                    return 'allow';
                }
            }
        }
        // it's no 'allow/modsublist' address, so if it's a newsletter quit 
        // (if newsletter, only 'allow'/modsublist' addresses can post)
        if($this->dbrow->mltype != 'm') {
            return 'deny';
        }
        if(is_array($this->deny)) {
            foreach($this->deny as $pattern) {
                if(eregi($pattern, $address)) {
                    return 'deny';
                }
            }
        }
        //-----------------------------------------------
        // TODO: insert check for disabled sender
        // $query = 'select count(*) from '.$this->subscribers." where emailaddress = '$address' and state = 'enabled'"
        //-----------------------------------------------
        if(strcasecmp($this->dbrow->subscribersonly,'yes')) {    // ml is open to all
            return 'subscribed';
        }
        if(preg_match('/(^|\n)'.$address.'(\n|$)/i',$this->sublist)) {
            $retval = 'subscribed';
        }
        if(preg_match('/(^|\n)'.$address.'(\n|$)/i',$this->digestsublist)) {
            $retval = (!strcmp($retval,'deny') ? '' : $retval) . 'digest';
        }
        return $retval;
    }

    function ListMessages() {
        $result=$this->pop3->ListMessages("",0);
        if(GetType($result)=="array") {
            for(Reset($result),$message=0;$message<count($result);Next($result),$message++) {
                    echo "Message ",Key($result)," - ",$result[Key($result)]," bytes.\n";
            }
            $result=$this->pop3->ListMessages("",1);
            if(GetType($result)=="array") {
                for(Reset($result),$message=0;$message<count($result);Next($result),$message++) {
                    echo "Message ",Key($result),", Unique ID - \"",$result[Key($result)],"\"\n";
                }
            }
        }
    }

    function CacheMessage() {
        if(!file_exists($this->cachepath)) {
            return;
        }
        if(!file_put_contents($this->cachepath.$this->listname.'-'.date("Ymd-H:i:s").'.eml',
                str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers'])).
                "\r\n".str_replace("'","\\'",$this->decoded[0]['Body']))) {
            return;
        }
        sleep(1);    // to avoid 2 messages with the same path
    }

    function Pop3Start() {

        $temp = explode(':',$this->dbrow->hostname);
        $this->pop3->hostname=$this->listhostname=$temp[0];   /* POP 3 server host name                      */
        $this->pop3->port=$this->listport=$temp[1];           /* POP 3 server host port,
                                                                 usually 110 but some servers use other ports
                                                                 Gmail uses 995                              */
        $this->pop3->tls=$this->listtls=$temp[2];             /* Establish secure connections using TLS      */
        $this->pop3->realm="";                                /* Authentication realm or domain              */
        $this->pop3->workstation="";                          /* Workstation for NTLM authentication         */
        $this->pop3->authentication_mechanism="USER";         /* SASL authentication mechanism               */
        if($this->pop3Debug)
            $this->pop3->debug=1;                             /* Output debug information                    */
        //$this->pop3->html_debug=1;                          /* Debug information is in HTML                */
        //$this->pop3->join_continuation_header_lines=1;      /* Concatenate headers split in multiple lines */
    }

    /* check for new messages */
    function Pop3Read() {
        $retval = '';
        $apop=0;
        $user=$this->listuser;
        $password=$this->listpassword;
        $this->error='';
        $messages='';
        $address = '';
        $substate = 'deny';
        $messageid = '';

        if(($this->error=$this->pop3->Open())!="") {
            return $this->error;
        }
        if(($this->error=$this->pop3->Login($user,$password,$apop))!="") {
            echo "Connection error: $this->error\n<br>";
            return $this->error;
        }
        if(($this->error=$this->pop3->Statistics($messages,$size))=="")
        {
            echo "$messages mess.".($size > 0 ? " total size [$size]" : '');
            for($i=0; $i < $messages; $i++)
            {
                $error = '';
                $this->pop3->GetConnectionName($connection_name);
                $message=$i + 1;
                $size = $this->pop3->ListMessages($message,0);
                echo " # $message, size [$size]: ";
                $message_file='pop3://'.$connection_name.'/'.$message;
                $mime=new mime_parser_class;
                $mime->decode_bodies = 0;
                if($size > $this->maxmsgsize) {
                    $mime->decode_bodies = 1;
                    echo " Warning [exceeding].";
                }
                $parameters=array(
                    'File'=>$message_file //, 'SaveBody'=>1,
                );
                $success=$mime->Decode($parameters, $this->decoded);
                if(!$success) {
                    echo 'MIME message decoding error: '.HtmlSpecialChars($mime->error)." .";
                } else {
                    if($this->cachemessages) {
                        $this->CacheMessage();
                    }
                    if(!strcasecmp($this->removeAfterPop,'yes')) {
                        $this->error.=$this->RemoveMessage($message)."\n";
                    }
                    $address = $this->decoded[0]['ExtractedAddresses']['from:'][0]['address'];
                    if(isset($this->decoded[0]['Headers']['message-id:'])) {
                        $messageid = $this->decoded[0]['Headers']['message-id:'];
                    }
                    // now rebuild sublist fields because there could be some changes in this ML
                    // or, eventually, parent/children ML
                    $this->InitSublistFields();
                    $substate=$this->CheckSender($address);
                    if($this->CheckMlCommand($address,$substate) == true) {  // got ML command, jump
                        continue;
                    }
                    if(!strstr($substate,'mailer') && !strstr($substate,'deny')) {
                    /* message is ready for delivery, check 'filter' for any kind of rule */
                        if($this->MailFilter($address) == true) {
                            $this->SendMessage($address,$size);
                        }
                        continue;
                    }
                    echo "[$substate] sorry, you are not subscribed yet and/or not allowed to post. Sender [$address] message-id [$messageid]";
                    if(!strstr($substate,'mailer')) {
                        $this->SendSubscriptionError(
                            $this->GetReturnPath($address),false,'UNSUBSCRIPTION ERROR STATE');
                    }
                }
            }
        }
        echo $this->logcr."\n";
        // moved after this function to ensure closing the connection
        //$this->error=$this->pop3->Close();
        $retval = $this->error;
        return $retval;
    }

    function AddTrailer(&$mailbody) {
        $retval = '';

        if(strlen($this->dbrow->trailerfile) <= 0) {
            return;
        }
        $content_type = explode(';',$this->decoded[0]['Headers']['content-type:']);
        $content_type[0] = trim($content_type[0]);
        // if(!strstr($content_type[0],'alternative') && !strstr($content_type[0],'digest')
        // && !strstr($content_type[0],'mixed')) {
        if(!$content_type[0] || strstr($content_type[0],'text/plain')) {
            $mailbody.="\r\n".$this->SetText($this->dbrow->trailerfile)."\r\n";
            return;
        }
        // no text/plain message. search 'text/plain' first, 'text/html' after
        preg_match('/(.*)(\r|)\nContent-Type: text\/plain/i',
            $mailbody,$matches,PREG_OFFSET_CAPTURE,1);
        if($matches[0][0]) {
            $pos=$matches[0][1];
            $pos+=25;    // add 'Content-Type: text/plain' character length
            $nextpart=trim(strtok($matches[0][0],"\r\n"));
            // search for last 'NextPart' of this body part
            $last=strpos(substr($mailbody,$pos),$nextpart);
            $last+=$pos - 2;
            if($mailbody[$last] == "\n" || $mailbody[$last] == "\r") {
                $last-=2;
            }
            $mailbody=substr($mailbody,0,$last)."\r\n".
                $this->SetText($this->dbrow->trailerfile).
                substr($mailbody,$last)."\r\n";
        }
        preg_match('/(.*)(\r|)\nContent-Type: text\/html/i',
            $mailbody,$matches,PREG_OFFSET_CAPTURE,1);
        if($matches[0][0]) {
            $pos=$matches[0][1];
            $pos+=24;    // add 'Content-Type: text/html' character length
            $nextpart=trim(strtok($matches[0][0],"\r\n"));
            // search for last 'NextPart' of this body part
            $last=strpos(substr($mailbody,$pos),$nextpart);
            $last+=$pos - 2;
            preg_match('/(\r|)\n<\/body>(\r|)\n<\/html>(\r|)\n/i',
                substr($mailbody,$pos,$last),$matches,PREG_OFFSET_CAPTURE,1);
            if($matches && $matches[0][1]) {
                $mailbody=substr($mailbody,0,$pos+$matches[0][1])."\r\n<br>".
                    $this->SetText($this->dbrow->trailerfile).
                    substr($mailbody,$pos+$matches[0][1]+1)."\r\n";
            }
        }
        return;
    }

    function CheckQueueTime(&$row, &$msgrow) {
        $now=strtotime('now');
        $messagetime=strtotime($msgrow->mldate);
        $queuetime=strtotime($row->mldate);
        $timeqm=$queuetime-$messagetime;
        $mult=($timeqm - ($timeqm % (24*60*60))) / (24*60*60) + 1;
        if($this->debug) {
            echo "messagetime [$messagetime] [".date(DATE_RFC822,$messagetime)."]\n";
            echo "queuetime [$queuetime] [".date(DATE_RFC822,$queuetime)."]\n";
            echo "now [$now] [".date(DATE_RFC822,$now)."]\n";
            echo "timeqm: [".$timeqm."]\n";
            echo "mult: [".$mult."]\n";
            echo "time: [".($this->mintimeresendmsg *$mult)."]\n";
            echo "time passed from last send and message date: [$timeqm]\n";
            echo "time passed from last send and now: [".($now-$queuetime)."]\n";
        }
        if(($now - $queuetime) <= ($this->mintimeresendmsg * $mult)) {
            return false;
        }
        return true;
    }

    function SendFromQueue() {
        $query = "select * from $this->queue where mltable = '$this->listname'";
        $result = @mysql_query($query,$this->dbconn);
        while($row = @mysql_fetch_object($result)) {
            // get entire message row
            $messageid = $row->messageid;
            $query = "select * from $this->messagesTable where id = $messageid";
            $msgresult = @mysql_query($query,$this->dbconn);
            if(!$msgrow = @mysql_fetch_object($msgresult)) {
                // there is not a associated message, remove queue record
                $query = "delete from queue where id = $row->id";
                $command = @mysql_query($query,$this->dbconn);
                continue;
            }
            // check if message is expired
            if($this->CheckQueueTime($row,$msgrow) != true) {
                // not enaught time has passed, retry later
                continue;
            }
            // ok, try to resend message
            echo "sending from queue # $messageid; ";
            // change smtp server if any
            $this->smtpindex = $row->smtp + 1;
            if($this->smtpindex > (sizeof($this->mlsmtp) - 1)) {
                $this->smtpindex = 0;
            }
            $addresses = explode(',', $row->addresses);
            $addresserror = '';
            foreach($addresses as $address) {
                // remove error code (if exists) from address
                $address = preg_replace('/^\[.*\]/','',$address);
                $pos=strpos($msgrow->message,"\r\n\r\n");
                if(!$pos) $pos=strpos($msgrow->message,"\n\n");
                $error = $this->SmtpSend($address, $msgrow->subject, $this->listaddress,
                    substr($msgrow->message,0,$pos),
                    substr($msgrow->message,$pos+2));
                if($error != 'OK.') {
                    if($error[0] == '5') {
                        $bounceerror.="[$error]$address\n";
                    } else {
                        echo " error [$error] for [$address];";
                        $addresserror.=((strlen($addresserror) <= 0) ? '': ',').
                            "[$error]$address";
                    }
                } else {
                    $ok++;
                }
            }
            if(strlen($addresserror) > 1) {
                $query = "update queue set mldate = now()".
                    ", addresses = '".str_replace("'","\\'",$addresserror).
                    "', smtp = $this->smtpindex where id = $row->id";
                $command = @mysql_query($query,$this->dbconn);
            } else {
                $query = "update messages set state = 'sent', smtp = '".
                    $this->smtpindex."' where id = $messageid";
                $command = @mysql_query($query,$this->dbconn);
                $query = "delete from queue where id = $row->id";
                $command = @mysql_query($query,$this->dbconn);
            }
            if(strlen($bounceerror) > 1) {
                $this->NotifyBounce($messageid,$bounceerror);
            }
            @mysql_free_result($msgresult);
        }
        @mysql_free_result($result);
        $this->smtpindex = 0;
        return true;
    }

    function ApplyNotifyFilterCommand($address, $text) {
        $id = md5(uniqid(rand(), true));
        $mailheader = '';
        $mailsubject = $this->GetText('NOTIFY SUBJECT',true)."[$this->listaddress] <$address>";

        $boundary='----NextPart'.md5(date('r', time()));
        $mailheader.="Return-Path: ".$this->listowner."\r\nPrecedence: bulk\r\n";
        $mailheader.="From: ".$this->listaddress."\r\nMIME-Version: 1.0\r\nContent-Type: multipart/report; boundary=".
            $boundary."\r\n";
        $mailheader.='Subject: '.$mailsubject."\r\n";
        $mailbody ='--'.$boundary."\r\nContent-Type: text/plain; charset: us-ascii\r\n\r\n".
            $text."\r\n\r\noriginal message:\r\n\r\n";
        $mailbody.='--'.$boundary.
            "\r\nContent-Type: message/rfc822\r\nContent-Disposition: inline; filename=\"msg.eml\"\r\n\r\n".
            str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers']))."\r\n".
            str_replace("'","\\'",$this->decoded[0]['Body'])."\r\n\r\n".'--'.$boundary."--\r\n\r\n";
        $error = $this->SmtpSend($address, $mailsubject, $this->listaddress, $mailheader, $mailbody);
        if($error != 'OK.') {
            $this->NotifyOwner($address,'User notification failed, ml ['.$this->listaddress.'] for address <'.
                $address.'>');
        }
    }

    function ApplyCommand(& $address, & $header, & $body, $command) {
        echo " matching filter, ";
        $retval = true;
        //$cmd=explode(' ',$command);
        for($i=0; $i < sizeof($command); $i++) {
            $cmd = trim(strtolower(strtok($command[$i],' ')));
            if($this->debug) {
                $this->debugOutput .= "\nMATCHING FILTER: $cmd\n";
            }
            // check if command is commented with `#' to disable it
            if($cmd[0] && $cmd[0] == '#') {
                echo "ignoring filter; ";
                continue;
            }
            switch(strtolower(trim($cmd))) {
                case 'drop':         // catched "drop", don't send message
                    echo "applying [$cmd] filter; ";
                    $retval = false;
                    break;
                case 'owner':        // notify owner
                    $this->NotifyOwner($address,
                        'Filter notification, ml ['.$this->listaddress.'] for address <'.
                            $address.'>',
                        strtok('')."\r\n\r\n");
                    break;
                case 'store':        // store message if CACHE_MESSAGES is not true
                    echo "applying [$cmd] filter; ";
                    if($this->cachemessages == false) {
                        $this->CacheMessage();
                    }
                    break;
                case 'notify':        // notify user
                    echo "applying [$cmd] filter; ";
                    $this->ApplyNotifyFilterCommand($address,strtok(''));
                    break;
                case 'redirect':    // redirect message
                case 'forward':        // alias of redirect
                    echo "applying [$cmd] filter; ";
                    $recipients = explode(',',str_replace(' ','',strtok('')));
                    $error = $this->SmtpSend($recipients, $mailsubject, $address, $header, $body);
                    if($error != 'OK.') {
                        $this->NotifyOwner($address,"Filter [$cmd] failed, ml [$this->listaddress] for address <$address>");
                    }
                    break;
            }
        }
        return $retval;
    }

    function ApplyFilter(& $address, & $pattern, & $buffer) {
        foreach($pattern as $rgx) {
            if(strlen($rgx) <= 1)
                continue;
            $flag = false;
            if($rgx[0] == '!') {
                $flag = true;    // invert regexp result
                $rgx = substr($rgx,1);
            }
            $stat = @preg_match('/'.str_replace('/','\/',$rgx).'/im',$buffer);
            if((!$stat && $flag == false) || ($stat && $flag == true)) {    // one regexp failed, no match, quit
                return false;
            }
        }
        // every regexp matched, apply command
        return true;
    }

    function MailFilter($address) {
        if(strlen($this->dbrow->mailfilter) < 10)
            return true;
        $header = '';
        $retval = true;
        $body = & $this->decoded[0]['Body'];
        $filter = explode(':0',$this->dbrow->mailfilter);
        foreach($filter as $rule) {
            if(strlen($rule) < 3)
                continue;
            $rule = str_replace("\r",'',$rule);
            $pos = strpos($rule,"\n");
            $flag = substr($rule,0,$pos);
            $rule = substr($rule,$pos);
            $pattern = array();
            $command = array();
            while(strlen($rule)) {
                $token = trim(strtok($rule,"\n"));
                if(strlen($token) > 1) {
                    if($token[0] == '*') {
                        $pattern[] = trim(substr($token,1),"\n\r;,. ");
                    } else {
                        $command[] = trim($token,"\n\r;,. ");
                    }
                }
                $rule = strtok("");
            }
            $status = false;
            if(!strcasecmp($flag,' h') || !strcasecmp($flag,'')) {
                if(!$header) {
                    $header = $this->ImplodeHeaders('',$this->decoded[0]['Headers']);
                }
                if($this->ApplyFilter($address,$pattern,$header) == true) {
                    $status = true;
                }
            }
            if(!strcasecmp($flag,' b') || !strcasecmp($flag,'')) {
                if($this->ApplyFilter($address,$pattern,$body) == true) {
                    $status = true;
                }
            }
            if($status == true) {
                // if there is just one "drop" set retval to false, message won't be sent
                if($this->ApplyCommand($address,$header,$body,$command) == false) {
                    $retval = false;
                }
            }
        }
        return $retval;
    }

    /*
     *  regexp sample:
     *  thanks to Gregor Buchholz
     *  Subject [Bigband-__LISTNAME__] \\1 {/(.*)/i}
     */
    function RebuildHeader (& $mailheader) {
        $headers=explode("\n",$this->headersadd);
        foreach($headers as $token) {
            $hkey = trim(strtolower(strtok($token,': ')));
            $replace = trim(strtok("{"));
            $pattern = trim(strtok(''),"}");
            $header = & $this->decoded[0]['Headers']["$hkey:"];
            if($header) {
                if(strlen($replace) <= 0) {    // header key only, no pattern, no value, remove header
                    unset($this->decoded[0]['Headers']["$hkey:"]);
                    continue;
                }
            } else {
                if(strlen($replace) <= 0) {    // no header, but no value, jump
                    continue;
                }
                $this->decoded[0]['Headers']["$hkey:"] = '';
                $header = & $this->decoded[0]['Headers']["$hkey:"];
            }
            if(strlen($pattern) <= 0) {
                $pattern = '/(.*)/';
            }
            $header = preg_replace($pattern,$replace,$header,1);
        }
        // rebuild mail headers
        foreach($this->decoded[0]['Headers'] as $key => $val) {
            if(is_array($val)) {
                foreach($val as $token) {
                    $mailheader .= $key.' '.trim($token,"\n\r ")."\r\n";
                }
            } else if(strlen($val) > 0) {
                $mailheader .= $key.' '.trim($val,"\n\r ")."\r\n";
            }
        }
    }

    /* send section */
    function SendMessage($sender,$msgsize) {
        $error = '';
        $messageid = -1;
        $mailheader = '';
        $mailbody = '';
        $mailsubject = '';
        $ok = 0;

        $modstate = 'sent';
        if(!strcmp($this->moderatedlist,'yes')) {
            $modstate = 'pending';
        }
        if($msgsize > $this->maxmsgsize) {
            $mailsubject=$this->GetText('NOTIFY SUBJECT',true).' '.$this->listaddress;

            $mailbody=$this->GetText('EXCEEDING MSG SIZE',true).$this->maxmsgsize."\r\n\r\n".
                "------------------------------------------------\r\n\r\n".$mailsubject."\r\n\r\n";
// TODO: insert original message as attachment
            $this->NotifyUser($sender,false,$mailsubject,$mailbody);
            return;
        }
        $mailbody=&$this->decoded[0]['Body'];
        $mailbody.=$this->AddTrailer($mailbody);
        $mailsender = $this->listaddress; // if smtp require authentication
        $mailsubject = stripslashes($this->decoded[0]['Headers']['subject:']);
        if(!strcmp($modstate,'pending')) {
            if(eregi("(^|\n)$sender(\n|$)",$this->modsublist)
            && preg_match('/\b'.$this->GetText('CONFIRM',true).'\b.\b('.$this->GetText('MESSAGE',true).')\b.'.$this->listname."\.([A-Za-z0-9]+)\.(.*)/i", $this->bodytextplain, $matches,PREG_OFFSET_CAPTURE)) {
                $query="select * from $this->messagesTable where state = 'pending' && keyvalue = '".
                    $matches[2][0]."'";
                if($result = @mysql_query($query,$this->dbconn)) {
                    if($row = @mysql_fetch_object($result)) {
                        $query = "update $this->messagesTable set state = 'queued' where id = $row->id";
                        if(!$this->debug) {
                            @mysql_query($query,$this->dbconn);
                        }
                        $messageid = $row->id;
                        $parameters=array(
                            'Data'=>$row->message //, 'SaveBody'=>1,
                        );
                        unset($this->decoded);
                        $mime=new mime_parser_class;
                        $mime->decode_bodies = 0;
                        $success=$mime->Decode($parameters, $this->decoded);
                        if(!$success) {
                            echo 'MIME message decoding error: '.HtmlSpecialChars($mime->error)." .";
                            return;
                        }
                        $mailbody=& $this->decoded[0]['Body'];
                        @mysql_free_result($result);
                    } else { // key doesn't match, notify owner
                        $this->NotifyOwner($sender,
                            'Message moderation failed, ml ['.$this->listaddress.']'.$address.'>');
                        @mysql_free_result($result);
                        return;
                    }
                }
                $modstate = 'sent';
            } else {
                $this->NotifyMessageModeration($sender);
                return;
            }
        }
        $this->RebuildHeader($mailheader);
        $addresserror = '';
        $bounceerror = '';
        echo "Sending, ";
        $sublist = explode("\n",$this->sublist);
        if(sizeof($sublist) > 0) {
            // set recipients number per smtp connection
            $recipients = $this->ArraySplit($sublist);
            foreach($recipients as $recipient) {
                $error = $this->SmtpSend($recipient, $mailsubject, $mailsender, $mailheader, $mailbody);
                if($error != 'OK.') {
                    echo " sending error [$error];";
                    // if ok is a permanent error, don't queue and notify to owner
                    if($error[0] == '5') {
                        $bounceerror.="[$error]".implode("\n[$error]",$recipient)."\n";
                    } else {
                        $addresserror.="[$error]".implode(",[$error]",$recipient).',';
                    }
                } else {
                    $ok += sizeof($recipient);
                }
            }
            if(strlen($bounceerror) > 1)
                $bounceerror = substr($bounceerror,0,-1);
            if(strlen($addresserror) > 1)
                $addresserror = substr($addresserror,0,-1);
        }
        if(!strcmp($modstate,'sent') && strlen($addresserror) > 1) {
                $modstate = 'queued';
        }
        // ok, insert message into archive
        if($messageid > 0) {
            $query = "update $this->messagesTable set state = '$modstate' where id = $messageid";
        } else {
            $query = "insert into ".$this->messagesTable.
                " (id,mldate,state,mltable,smtp,mailfrom,subject,message,header,rowlock) values(0,now(),'".
                "$modstate','$this->listname','$this->smtpindex','$sender','".
                str_replace("'","\\'",$mailsubject)."','".
                str_replace("'","\\'",$mailheader)."\r\n".str_replace("'","\\'",$mailbody)."','".
                str_replace("'","\\'",$this->ImplodeHeaders('',$this->decoded[0]['Headers'])).
                    "','')";
        }
        if(!$this->debug) {
            $command = @mysql_query($query,$this->dbconn);
            if($messageid == -1) {
                $messageid = @mysql_insert_id($this->dbconn);
            }
            echo "msgid [$messageid]:";
            if(strlen($addresserror) > 1) {
                $query = "insert into queue (id, mldate, smtp, mltable, messageid, addresses, rowlock) values(0,now(),'".
                    "$this->smtpindex','$this->listname',$messageid,'".
                    str_replace("'","\\'",$addresserror)."','')";
                $command = @mysql_query($query,$this->dbconn);
            }
        }
        // check if there are permanent error and send them to owner
        if(strlen($bounceerror) > 1) {
            $this->NotifyBounce($messageid,$bounceerror);
        }
        echo " sent # $ok. End";
    }

    function CheckDigestByDate() {
//----------------------------------------------
// for debug only
//$this->now = strtotime("2009/04/27 18:00:00");
//----------------------------------------------
        $exptime=$this->senddigest;
        if(!is_numeric(substr($exptime,0,1))) {
            $daycheck=strtolower(substr($exptime,0,3));
            if(strcasecmp($daycheck,date('D',$this->now))) {
                return false;
            }
            // ok, the day is good, go on
            $exptime=substr($exptime,4);
        }
        if(strpos($exptime,':')) {
            if(strcmp($exptime,date('H:i',$this->now))) {
                return false;
            }
            // there is no constant time, but numeric value ('1' for every hour,'12' for every 12 hours)
        } else {
            $now=(date('H',$this->now) * 60)+date('i',$this->now);
            if((($now % ($this->senddigest *60)) / ($this->senddigest *60)) <> 0) {
                return false;
            }
        }
        // ok it's send time
        $query = "select * from $this->messagesTable where state = 'sent' and".
        // if you want to check 'from date' too enable row below
        //    (" mldate > '".date("Y/m/d H:i:s",$this->now - ($this->senddigest * 60 * 60)) . "' and") : '').
            " mldate <= '".date("Y/m/d H:i:s",$this->now)."' order by mldate limit ".$this->digestmaxmsg;
        if(!$result=@mysql_query($query,$this->dbconn)) {
            return false;
        }
//echo "query: $query\n";
        return $result;
    }

    function SendDigest() {
        $result=null;

        if(strlen($this->digestsublist) < 5) {    // no digesto subscribers, exit from here
            return;
        }
        if(!$result=$this->CheckDigestByDate())
            return;
        $mailsubject = '';
        $mailheader = '';
        $mailbody = '';
        $boundary = '';
        $digestlist = '';
        $maxsize=(DIGEST_MAX_SIZE != false ? DIGEST_MAX_SIZE : $this->dbrow->digestmaxsize);
        if(!$maxsize)
            $maxsize = '64K';
        // foreach($this->headersadd as $hk => $hv) { if(strcmp($hv,'')) { $mailheader.= $hk.': '.$hv."\r\n"; } }
        $mailheader.= "Precedence: bulk\r\n";
        $boundary='----NextPart'.md5(date('r', time()));
        $mailheader.="From: ".$this->listaddress."\r\nMIME-Version: 1.0\r\nContent-Type: multipart/digest; boundary=".
            $boundary."\r\n";

        $mailsubject.='Subject: '.$this->listname." Digest: ";
        $mailbody.='--'.$boundary."\r\nContent-Type: text/plain; charset: us-ascii\r\n\r\n".
            $this->listname." Digest:\r\n\r\n";
        $firstid=null;
        $lastid=null;
        if(!strcasecmp($maxsize[strlen($maxsize)-1],'k')) {
            $maxsize*=1024;
        } else if(!strcasecmp($maxsize[strlen($maxsize)-1],'m')) {
            $maxsize*=1024*1024;
        }
        echo 'digest for msg# '.$row->id."; mldate: ".$row->mldate."\n";
        while($row = @mysql_fetch_object($result)) {
            if($firstid==null) {
                $firstid=$row->id;
            }
            $lastid=$row->id;
            echo $row->id."; ";
            $mailbody.="Id: ".$row->id."\r\nSender: ".$row->mailfrom."\n\nSubject: ".$row->subject."\r\n";
            $maxsize -= strlen($row->message);
            if($maxsize <= 0) {    // digest message exceeds max size
                $mailbody.="Warning! Exceding max size, this message can be retrieved with ML command:\r\nget.".
                    $row->id."\r\n";
            } else {
                $digestlist.='--'.$boundary.
                    "\r\nContent-Type: message/rfc822\r\nContent-Disposition: inline; filename=\"msg".$row->id.".
                    eml\"\r\n\r\n".$row->message."\r\n\r\n";
            }
            $mailbody.="\r\n\r\n";
        }
        @mysql_free_result($result);
        if(!$firstid) {        // no messages for digest
            return;
        }
        $mailsubject.=$firstid.'-'.$lastid."\r\n";
        $mailheader.=$mailsubject;
        $mailbody.=$digestlist.'--'.$boundary."--\r\n\r\n";
        unset($digestlist);
        $digestsublist=explode("\n",$this->digestsublist);
        if(sizeof($digestsublist) > 0) {
            foreach($digestsublist as $mailaddress) {
                if(strlen($mailaddress) < 5) continue;
                $mailaddress = stripslashes($mailaddress);
                $error = $this->SmtpSend($mailaddress,$mailsubject,$this->listaddress,$mailheader,$mailbody);
                if($error != 'OK.') {
                    echo " digest-error [$error] for [$mailaddress];";
                    $addresserror.=((strlen($addresserror) <= 0) ? '': ',').$mailaddress;
                } else {
                    $ok++;
                }
            }
        }
        if($ok > 0 && _DIGEST_DATE_MODE != true) {
            $query = "update $this->messagesTable set state = 'sentdigest' where state = 'sent' limit ".
                $this->digestmaxmsg;
            if(!$result=@mysql_query($query,$this->dbconn)) {
                echo " digest-error, messages 'state' not changed;";
            }
        }
    }

    function ValidateLockTime($buffer) {
        if(!strcmp($buffer,''))
            return true;
            $buffer = substr($buffer, strpos($buffer,'-')+1);
            // echo "<!-- diff # ".(strtotime('now') - strtotime(str_replace('-',' ',$buffer)))."-->\n";
            if((strtotime('now') - strtotime(str_replace('-',' ',$buffer))) > ($this->expirelock ? $this->expirelock : EXPIRE_LOCK)) {
                return true;
            }
            return false;
    }

    function LockMl() {
        if($this->ValidateLockTime($this->dbrow->rowlock) != true) {
            return false;
        }
        $query = "update ".addslashes($this->mltable)." set rowlock = '".
            $_SERVER['REMOTE_ADDR'].'-'.date('Y/m/d-H:i:s')."' where listname = '".$this->listname."'";
        if(!@mysql_query($query,$this->dbconn)) {
            return false;
        }
        return true;
    }
    function UnlockMl() {
        $query = "update ".addslashes($this->mltable)." set rowlock = '' where listname = '".$this->listname."'";
        if(!@mysql_query($query,$this->dbconn)) {
            return false;
        }
    }

    function Run() {
        /* save start time for some time checks because it could be delayed by big messages, many subscribers...*/
        $this->now = strtotime('now');
        echo $this->logheader;
        echo date("Y/m/d H:i:s").". ".$this->listname.": ";
        if($this->Init() != true) {
            echo $this->logfooter;
            return;
        }
        if(!strcmp($this->dbrow->shutdown,'yes')) {
            echo "ML disabled. quit";
        } else if($this->LockMl() != true) {
            echo "already locked. quit";
        } else {
            $this->SendFromQueue();
            $this->Pop3Start();
            $this->error=$this->Pop3Read();
            if(strcasecmp($this->pop3->state,"DISCONNECTED"))
                $this->error=$this->pop3->Close();
            $this->SendDigest();
            $this->UnlockMl();
        }
        if($this->debug) {
            echo str_replace("\n","<br>\n",htmlentities($this->debugOutput)."\n");
        }
        echo $this->logfooter;
    }
};

?>
