-- MySQL dump 10.11
--
-- Host: localhost    Database: pop3ml
-- ------------------------------------------------------
--
-- Table structure for table `messages`
--

DROP TABLE IF EXISTS `messages`;
CREATE TABLE `messages` (
  `id` int(11) NOT NULL auto_increment,
  `mldate` datetime default NULL,
  `state` set('sent','sentdigest','pending','queued') default NULL,
  `mltable` varchar(128) default NULL,
  `smtp` varchar(128) default NULL,
  `mailfrom` text,
  `subject` text,
  `message` longtext,
  `header` longtext,
  `keyvalue` varchar(128),
  `rowlock` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `messages`
--

--
-- Table structure for table `mltable`
--

DROP TABLE IF EXISTS `mltable`;
CREATE TABLE `mltable` (
  `id` int(11) NOT NULL auto_increment,
  `typology` set('default') default NULL,
  `listname` varchar(128) default NULL,
  `hostname` tinytext,
  `listaddr` tinytext,
  `listuser` tinytext,
  `listpoppass` tinytext,
  `listowneremail` tinytext,
  `parentlist` text,
  `msgsize` varchar(32),
  `smtpserver` longtext,
  `mltype` set('m','n'),
  `confirmsub` set('yes','no'),
  `confirmunsub` set('yes','no'),
  `moderatedlist` set('yes','no'),
  `subscriptionmod` set('yes','no'),
  `subscribersonly` set('yes','no'),
  `removeafterpop` set('yes','no'),
  `shutdown` set('yes','no'),
  `recipientlimit` int(11),
  `senddigest` varchar(32),
  `digestmaxsize` varchar(32),
  `digestmaxmsg` varchar(32),
  `sublist` longtext,
  `modsublist` longtext,
  `denysublist` longtext,
  `allowsublist` longtext,
  `digestsublist` longtext,
  `mailfilter` longtext,
  `headerchange` longtext,
  `trailerfile` longtext,
  `language` longtext,
  `rowlock` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `listname` (`listname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `queue`
--

DROP TABLE IF EXISTS `queue`;
CREATE TABLE `queue` (
  `id` int(11) NOT NULL auto_increment,
  `mldate` datetime default NULL,
  `smtp` varchar(128) default NULL,
  `mltable` varchar(64) default NULL,
  `messageid` varchar(12) default NULL,
  `addresses` longtext,
  `rowlock` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `subqueue`
--

DROP TABLE IF EXISTS `subqueue`;
CREATE TABLE `subqueue` (
  `code` varchar(128) NOT NULL,
  `request` set('subscription','unsubscription') default NULL,
  `keyvalue` varchar(128) default NULL,
  `mldate` datetime default NULL,
  `rowlock` text,
  PRIMARY KEY  (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `subscribers`
--

DROP TABLE IF EXISTS `subscribers`;
CREATE TABLE `subscribers` (
  `id` int(11) NOT NULL auto_increment,
  `emailaddress` varchar(128) default NULL,
  `state` set('enabled','disabled','suspended') default 'enabled',
  `webpass` tinytext default NULL,
  `rowlock` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `emailaddress` (`emailaddress`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- Dump completed on 2008-12-12  8:35:09
